<?php
/**
 * Created by PhpStorm.
 * User: francismararaujo
 * Date: 23/10/14
 * Time: 17:07
 */

namespace TecDiet\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;

use TecDiet\Services\BioEvaluationsService;

class BioEvaluationsController extends \Zeedhi\Framework\Controller\Simple {

    protected $bioEvaluationsService;

    public function __construct(BioEvaluationsService $bioEvaluationsService) {
        $this->bioEvaluationsService = $bioEvaluationsService;
    }

    public function save(Request\DataSet $request, Response $response) {

        $bioEvaluations = $request->getDataSet()->getRows();
        if($bioEvaluations) {

            try {
                
                $dataSet = $this->bioEvaluationsService->save($bioEvaluations);
                if(sizeof($dataSet)!=0){
                    $response->addDataSet(new DataSet('error', $dataSet));
                }

            } catch(\Exception $e) {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };

        }

    }

}