<?php
/**
 * Created by PhpStorm.
 * User: francismararaujo
 * Date: 23/10/14
 * Time: 17:07
 */

namespace TecDiet\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;

use TecDiet\Services\PrescriptionsService;

class PrescriptionsController extends \Zeedhi\Framework\Controller\Simple {

    protected $prescriptionsService;

    public function __construct(PrescriptionsService $prescriptionsService) {
        $this->prescriptionsService = $prescriptionsService;
    }

    public function save(Request\DataSet $request, Response $response) {

        $prescriptions = $request->getDataSet()->getRows();

        if($prescriptions) {

            try {
                
                $dataSet = $this->prescriptionsService->save($prescriptions);
                if(sizeof($dataSet)!=0){
                    $response->addDataSet(new DataSet('error', $dataSet));
                }

            } catch(\Exception $e) {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };

        }

    }

}