<?php
/**
 * Created by PhpStorm.
 * User: francismararaujo
 * Date: 23/10/14
 * Time: 17:07
 */

namespace TecDiet\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Method;

use TecDiet\Services\StructuresService;

class StructuresController extends \Zeedhi\Framework\Controller\Simple {

    protected $structuresService;

    public function __construct(StructuresService $structuresService) {
        $this->structuresService = $structuresService;
    }
    public function findPlates(Request\DataSet $request, Response $response){
        try {
            $params = $request->getDataSet()->getRows();
            $dataSet = $this->structuresService->findPlates($params[0]);
            $response->addDataSet(new DataSet('Plates', $dataSet));

        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        };
    }
    public function get(Request\Row $request, Response $response) {
        try {
            $units = $request->getRow();
            
            $structures = $this->structuresService->get($units['nutritionistID'], $units['unitID']);
            
            if(isset($structures['plates'])) {
                $response->addDataSet(new DataSet ('Plates', $structures['plates']));
            } else {
                $response->addDataSet(new DataSet('Plates', []));
            }
    
            if(isset($structures['foodGroup'])) {
                $response->addDataSet(new DataSet ('FoodIntoleranceGroup', $structures['foodGroup']));
            } else {
                $response->addDataSet(new DataSet('FoodIntoleranceGroup', []));
            }
    
            if(isset($structures['allGroupSubgroup'])) {
                $response->addDataSet(new DataSet ('AllGroupSubgroup', $structures['allGroupSubgroup']));
            } else {
                $response->addDataSet(new DataSet('AllGroupSubgroup', []));
            }
            
            if(isset($structures['platesByUnit'])) {
                $response->addDataSet(new DataSet ('PlatesByUnit', $structures['platesByUnit']));
            } else {
                $response->addDataSet(new DataSet('PlatesByUnit', []));
            }
            
            if(isset($structures['platesPla'])) {
                $response->addDataSet(new DataSet ('PlatesPla', $structures['platesPla']));
            } else {
                $response->addDataSet(new DataSet('PlatesPla', []));
            }
            
            if(isset($structures['lactaryPlates'])) {
                $response->addDataSet(new DataSet ('LactaryPlates', $structures['lactaryPlates']));
            } else {
                $response->addDataSet(new DataSet('LactaryPlates', []));
            }

            if(isset($structures['storeys'])) {
                $response->addDataSet(new DataSet ('Storeys', $structures['storeys']));
            } else {
                $response->addDataSet(new DataSet('Storeys', []));
            }
            
            if(isset($structures['halls'])) {
                $response->addDataSet(new DataSet ('Halls', $structures['halls']));
            } else {
                $response->addDataSet(new DataSet('Halls', []));
            }
            
            if(isset($structures['hallsDistincts'])) {
                $response->addDataSet(new DataSet ('HallsDistincts', $structures['hallsDistincts']));
            } else {
                $response->addDataSet(new DataSet('HallsDistincts', []));
            }
            
            if(isset($structures['beds'])) {
                $response->addDataSet(new DataSet ('Beds', $structures['beds']));
            } else {
                $response->addDataSet(new DataSet('Beds', []));
            }
            
            if(isset($structures['bedsPrescriptions'])) {
                $response->addDataSet(new DataSet ('BedsPrescriptions', $structures['bedsPrescriptions']));
            } else {
                $response->addDataSet(new DataSet('BedsPrescriptions', []));
            }
            
            if(isset($structures['services'])) {
                $response->addDataSet(new DataSet ('Services', $structures['services']));
            } else {
                $response->addDataSet(new DataSet('Services', []));
            }
            
            if(isset($structures['oralServices'])) {
                $response->addDataSet(new DataSet ('OralServices', $structures['oralServices']));
            } else {
                $response->addDataSet(new DataSet('OralServices', []));
            }
            
            if(isset($structures['lactaryServices'])) {
                $response->addDataSet(new DataSet ('LactaryServices', $structures['lactaryServices']));
            } else {
                $response->addDataSet(new DataSet('LactaryServices', []));
            }
            
            if(isset($structures['enteralServices'])) {
                $response->addDataSet(new DataSet ('EnteralServices', $structures['enteralServices']));
            } else {
                $response->addDataSet(new DataSet('EnteralServices', []));
            }
            
            if(isset($structures['diets'])) {
                $response->addDataSet(new DataSet ('Diets', $structures['diets']));
            } else {
                $response->addDataSet(new DataSet('Diets', []));
            }
            
            if(isset($structures['dietsServices'])) {
                $response->addDataSet(new DataSet ('DietsServices', $structures['dietsServices']));
            } else {
                $response->addDataSet(new DataSet('DietsServices', []));
            }
            
            if(isset($structures['dietsFields'])) {
                $response->addDataSet(new DataSet ('DietsFields', $structures['dietsFields']));
            } else {
                $response->addDataSet(new DataSet('DietsFields', []));
            }
            
            if(isset($structures['medicalTeams'])) {
                $response->addDataSet(new DataSet ('MedicalTeams', $structures['medicalTeams']));
            } else {
                $response->addDataSet(new DataSet('MedicalTeams', []));
            }
            
            if(isset($structures['nutritionalStatus'])) {
                $response->addDataSet(new DataSet ('NutritionalStatus', $structures['nutritionalStatus']));
            } else {
                $response->addDataSet(new DataSet('NutritionalStatus', []));
            }
            
            if(isset($structures['healthInsurance'])) {
                $response->addDataSet(new DataSet ('HealthInsurance', $structures['healthInsurance']));
            } else {
                $response->addDataSet(new DataSet('HealthInsurance', []));
            }
            if(isset($structures['accessRoads'])) {
                $response->addDataSet(new DataSet ('AccessRoads', $structures['accessRoads']));
            } else {
                $response->addDataSet(new DataSet('AccessRoads', []));
            }
            if(isset($structures['normalFeedingsNow'])) {
                $response->addDataSet(new DataSet ('NormalFeedingsNow', $structures['normalFeedingsNow']));
            }   else {
                $response->addDataSet(new DataSet('NormalFeedingsNow', []));
            }          
            if(isset($structures['formulations'])) {
                $response->addDataSet(new DataSet ('Formulations', $structures['formulations']));
            } else {
                $response->addDataSet(new DataSet('Formulations', []));
            }
            if(isset($structures['enteralPlates'])) {
                $response->addDataSet(new DataSet ('EnteralPlates', $structures['enteralPlates']));
            } else {
                $response->addDataSet(new DataSet('EnteralPlates', []));
            }
            if(isset($structures['enteralProducts'])) {
                $response->addDataSet(new DataSet ('EnteralProducts', $structures['enteralProducts']));
            } else {
                $response->addDataSet(new DataSet('EnteralProducts', []));
            }
            if(isset($structures['examinations'])) {
                $response->addDataSet(new DataSet ('Examinations', $structures['examinations']));
            } else {
                $response->addDataSet(new DataSet('Examinations', []));
            }
            if(isset($structures['dataTypeEvaluations'])) {
                $response->addDataSet(new DataSet ('DataTypeEvaluations', $structures['dataTypeEvaluations']));
            } else {
                $response->addDataSet(new DataSet('DataTypeEvaluations', []));
            }
            if(isset($structures['dataEvaluations'])) {
                $response->addDataSet(new DataSet ('DataEvaluations', $structures['dataEvaluations']));
            } else {
                $response->addDataSet(new DataSet('DataEvaluations', []));
            }
            if(isset($structures['AntroMethods'])) {
                $response->addDataSet(new DataSet ('AntroMethods', $structures['AntroMethods']));
            } else {
                $response->addDataSet(new DataSet('AntroMethods', []));
            }
            if(isset($structures['nutritionist'])) {
                $response->addDataSet(new DataSet ('nutritionist', $structures['nutritionist']));
            } else {
                $response->addDataSet(new DataSet('nutritionist', []));
            }
            if(isset($structures['Foods'])) {
                $response->addDataSet(new DataSet ('Foods', $structures['Foods']));
            } else {
                $response->addDataSet(new DataSet('Foods', []));
            }
            if(isset($structures['Dieta'])) {
                $response->addDataSet(new DataSet ('Dieta', $structures['Dieta']));
            } else {
                $response->addDataSet(new DataSet('Dieta', []));
            }
            if(isset($structures['DietPlate'])) {
                $response->addDataSet(new DataSet ('DietPlate', $structures['DietPlate']));
            } else {
                $response->addDataSet(new DataSet('DietPlate', []));
            }
            if(isset($structures['DietPlateServ'])) {
                $response->addDataSet(new DataSet ('DietPlateServ', $structures['DietPlateServ']));
            } else {
                $response->addDataSet(new DataSet('DietPlateServ', []));
            }
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        };

    }

}