<?php
/**
 * Created by PhpStorm.
 * User: francismararaujo
 * Date: 21/05/14
 * Time: 14:43
 */

namespace TecDiet\Util;

class Validation {

    public static function timeToFloat($time) {
        
        $time = explode(":", $time);

        $minutes = (string)($time[1] * 60 / 360);

        if (strpos($minutes, ".") !== false) {

            $minutes = explode(".", $minutes);

            return $time[0].",".$minutes[0].$minutes[1];

        } else {

            return $time[0].",".str_pad($minutes, 2, "0", STR_PAD_LEFT);

        }

    }

    public static function floatToTime($float) {
        if ($float === NULL || $float === '') {
            return '';
        }
        
        $float = preg_replace('/[,]/', '.', $float);
        $hours = floor($float);
        $mins = round(($float - $hours) * 60);
        return str_pad($hours, 2, '0', STR_PAD_LEFT) . ":" . str_pad($mins, 2, '0', STR_PAD_LEFT);
    }

    public static function getPregnancyName($pregnancyId) {

        switch ($pregnancyId) {

            case "S":
                    return 'Sim';
                break;

            case "N":
                    return 'Não';
                break;

        }

    }

    public static function getPreparationName($preparationId) {

        switch ($preparationId) {

            case "A":
                    return 'Aberto';
                break;
            case "F":
                    return 'Fechado';
                break;

        }

    }

    public static function getControlFeedingServiceName($serviceId) {

        switch ($serviceId) {

            case 0:
                    return 'NORMAL';
                break;
            case 1:
                    return 'LACTARIO';
                break;
            case 2:
                    return 'ENTERAL';
                break;
            case 3:
                    return 'ROOM SERVICE';
                break;
            case 4:
                    return 'ESPECIAL';
                break;

        }

    }
    public static function getControlFeedingRequester($stpaciacom) {
        switch ($stpaciacom) {
            case 0:
                    return "P";
                break;
            case 1: 
                    return "A";
                break;
        }
    }

    public static function removeAccentuation($string) {
        return preg_replace( '/[`^~\'"]/', null, iconv( 'UTF-8', 'ASCII//TRANSLIT', $string ) );
    }

    public static function isSelected($status) {

        if($status == "S") {
            return true;
        }else {
            return false;
        }

    }
    
    public static function removeAccents($text) {
        return strtr(utf8_decode($text), utf8_decode("áàãâéêíóôõúüçñṕýÁÀÃÂÉÊÍÓÔÕÚÜÇÑṔÝ"), "aaaaeeiooouucnpyAAAAEEIOOOUUCNPY");
    }

    public static function toPlainText($input) {

        $input = preg_replace('"{\*?\\\\.+(;})|\\s?\\\[A-Za-z0-9]+|\\s?{\\s?\\\[A-Za-z0-9]+\\s?|\\s?}\\s?"', '', $input);

        return strtr($input, 
            array(
                "\'e1" => "á", 
                "\'e0" => "à", 
                "\'e3" => "ã", 
                "\'e2" => "â",
                "\'c1" => "Á", 
                "\'c0" => "À", 
                "\'c3" => "Ã", 
                "\'c2" => "Â",
                "\'e9" => "é", 
                "\'e8" => "è", 
                "\'ea" => "ê",
                "\'c9" => "É", 
                "\'c8" => "È", 
                "\'ca" => "Ê",
                "\'ed" => "í", 
                "\'ec" => "ì", 
                "\'ee" => "î",
                "\'cd" => "Í", 
                "\'cc" => "Ì", 
                "\'ce" => "Î",
                "\'f3" => "ó", 
                "\'f2" => "ò", 
                "\'f5" => "õ", 
                "\'f4" => "ô",
                "\'d3" => "Ó",
                "\'d2" => "Ò", 
                "\'d5" => "Õ", 
                "\'d4" => "Ô",
                "\'fa" => "ú", 
                "\'f9" => "ù", 
                "\'fb" => "û", 
                "\'fc" => "ü",
                "\'da" => "Ú", 
                "\'d9" => "Ù", 
                "\'db" => "Û", 
                "\'dc" => "Ü",
                "\'e7" => "ç", 
                "\'c7" => "Ç",
                "\'aa" => "ª", 
                "\'ba" => "º",
                "<br>" => "\n"
            )
        );
    }
    public static function getAge($birthDay){
        $birth = str_replace('/', '-', $birthDay);
        $interval = date_diff(date_create(), date_create($birth));
        return array($interval->format('%y'), $interval->format('%m'));
    }
    
    public static function sanitazeNumber($stringToSanitaze, $isDot){
        if($isDot){
            $stringToSanitaze = preg_replace('/[,]/', '.', $stringToSanitaze);
        }else{
            $stringToSanitaze = preg_replace('/[.]/', ',', $stringToSanitaze);
        }
        // $stringToSanitaze = preg_replace('/[^0-9]/', '', $stringToSanitaze);
        return $stringToSanitaze;
    }
    
    public static function getYears($birthDay){
        $birthDate = $birthDay;
        $birthDate = explode("/", $birthDate); //explode the date to get month, day and year
        
        //get age from date or birthdate
        $age = (date("md", date("U", mktime(0, 0, 0, $birthDate[0], $birthDate[1], $birthDate[2]))) > date("md")
        ? ((date("Y") - $birthDate[2]))
        : (date("Y") - $birthDate[2]));
        return $age;
    }
}