function ruiController($rootScope, ScreenService, eventAggregator, templateManager) {

	eventAggregator.subscribe("beforeProjectStartup", function() {
		var interval = setInterval(function() {
			if (window.__back__) {
				window.__back__ = function() {
					if (ScreenService.isAlertShown()) {
						return;
					} else if ($rootScope.showAbout) {
						ScreenService.hideAbout();
					} else if (ScreenService.isPopupOpen()) {
						ScreenService.closePopup();
					} else if (ScreenService.isSideMenuOpen()) {
						ScreenService.toggleSideMenu();
					} else if ($rootScope.headerDropdownOpened) {
						toggleHeaderDropdown();
						$rootScope.$apply();
					} else if ($rootScope.searching) {
						toggleHeaderSearch();
						$rootScope.$apply();
					} else {
						var widget = getActiveWidget();
						if (widget.mode === 'edit' && widget.onCancel) {
							widget.onCancel();
						} else if (widget.widgetOnBack) {
							widget.widgetOnBack();
						} else if (widget.container && widget.container.onBack) {
							widget.container.onBack();
						} else {
							ScreenService.goBack();
						}
					}
				};
				clearInterval(interval);
			}
		}, 300);
		htmlFixesToRUI();
	});

	function getActiveWidget() {
		return templateManager.container.getActiveWidget();
	}
	function htmlFixesToRUI (){
		$('html').removeClass('splash');
		$('html').addClass('hide-scroll');
	}
}

Configuration(function(ContextRegister) {
	ContextRegister.register("ruiController", ruiController);
});

(function() {
	setInterval (function(){
		$('.container[zh-scroller]').scroll(function(){
			$('html').removeClass('hide-scroll');
			setTimeout(function(){
				$('html').addClass('hide-scroll');
			},1500);
		});
	},800);
})();
