describe('zhCalendar', function() {

	var $compile;
	var $rootScope;
	var i18nEngine;

	beforeEach(function() {
		module('ZeedhiServices');
		module('ZeedhiDirectives');
		inject(function(_$compile_, _$rootScope_, _i18nEngine_) {
			$compile = _$compile_;
			$rootScope = _$rootScope_;
			i18nEngine = _i18nEngine_;
		});
	});

	it('getCalendarHeading should call i18nEngine when retrieving month name', function() {
		moment.locale('en');
		$rootScope.widget = {};
		$rootScope.currentDate = moment('20170101');

		spyOn(i18nEngine, 'i18n').and.callFake(function() {
			return 'Janeiro';
		});

		var calendar = $compile("<section zh-calendar></section>")($rootScope);

		var calendarHeading = $rootScope.getCalendarHeading('day');
		expect(calendarHeading).toBe('Janeiro 2017');

		expect(i18nEngine.i18n).toHaveBeenCalledWith('January');
	});

});